sdtVGA_wait_vertical_retrace:
push ebx
push ecx
push edx
push esi



mov bh,11111111b;
mov eax,-1;
mov dx,922;
or dx,bx


.if__0.20535260743803863__68:
cmp dx,0x3BA
je .if__0.20535260743803863__68__end;
cmp dx,0x3DA
je .if__0.20535260743803863__68__end;
jmp .finish
.if__0.20535260743803863__68__end:


shl ecx,1







   ;Make a counter to wait up to 2
   ;vertical retraces, one potentially
   ;partial and one just starting to
   ;align the time to the vertical retrace
   ;we know is entire, as if this function
   ;actually returned that vertical retrace period:
   ;;
    mov bl,2


   ;This is the first loop, to wait for any residual
   ;vertical retrace period and discard it:
   ;;
    align 16
    .loop1:
      ;Read the port:
      ;;
       in al,dx;


      ;See if there's a vertical retrace.
      ;If bit3==1, then there's a vertical retrace in progress.
      ;We are interested in looping while there is not a vertical
      ;retrace, and decrease BL only at the time there is a vertical
      ;retrace, to return when a whole vertical retrace cycle starts.
      ;
      ;This VGA register bit is slow enogh as for our program
      ;to detect its changing state:
      ;;
       test al,00001000b
       jz .novertretraceinprogress;

        ;If we are here, there is a vertical retrace
        ;in progress (bit3==1). We decrease BL to make it go to 0,
        ;in which case we know it's time when the second,
        ;whole vertical retrace is in progress.
        ;;
         dec bl;


        ;This makes the optimization: If the vertical retrace was disabled
        ;when we just started looping, it means there was no previous vertical
        ;retrace in a partial state that we should discard. In that event, we
        ;set BH to 0, and by applying it to BL with AND, we effectively get
        ;a discarding counter to 0 just when the vertical retrace actually starts,
        ;and thus we return immediately with an optimized action:
        ;;
         and bl,bh
         jz .loop1_end;



        ;;;INIT: Second loop, to wait finish the first vertical retrace
        ;;;INIT: Second loop, to wait finish the first vertical retrace
        ;;;INIT: Second loop, to wait finish the first vertical retrace

            ;This is the second loop, to wait for the first
            ;vertical retrace period to end.
            ;Since we know that when we arrived here, the vertical
            ;retrace bit (bit3) was activated, now we wait for it to deactivate.
            ;That will cause to then go back with no vertical retrace in the first
            ;loop and to return from this function as soon as the vertical retrace
            ;activates again a second time, in the two lines just above
            ;this very comment and loop:
            ;;
             align 16
            .loop2:
            ;----------------------------------------------
            ;----------------------------------------------
            ;----------------------------------------------
              ;Read the port:
              ;;
               in al,dx;


              ;We wait for the vertical retrace bit to deactivate
              ;at which moment we exit this second loop:
              ;;
               test al,00001000b
               jz .loop2_end;

            ;----------------------------------------------
            ;----------------------------------------------
            ;----------------------------------------------
            loop .loop2;
            align 16
            .loop2_end:

        ;;;END:  Second loop, to wait finish the first vertical retrace
        ;;;END:  Second loop, to wait finish the first vertical retrace
        ;;;END:  Second loop, to wait finish the first vertical retrace



       align 16
       .novertretraceinprogress:




      ;See if the master loops counter is unaltered.
      ;If so, it means that when we entered, the vertical
      ;retrace was already disabled and thus we aren't required
      ;to discard a (non-existent) previous partial
      ;vertical retrace period:
      ;;
       ;cmp ecx,0x1FFFFFE
       cmp ecx,esi
       jne ._counter_altered


         ;This will set to 0 the counter that tells the outer
         ;loop whether there is a proper, complete, vertical retrace
         ;period starting:
         ;;
          mov bh,00000000b;

       ._counter_altered:





    loop .loop1;
    align 16
    .loop1_end:

 
.if__0.9071665058184517__110:
cmp ecx,0
je .if__0.9071665058184517__110__end;
mov eax,0;
.if__0.9071665058184517__110__end:
.finish:



pop esi
pop edx
pop ecx
pop ebx
ret
